"use strict";

/*!
 * CountTo v2.2.0
 * https://github.com/mhuggins/jquery-countTo
 *
 * Copyright Matt Huggins
 * Released under the MIT license
 */
!function(t){"function"==typeof define&&define.amd?define(["jquery"],t):"object"==typeof exports?t(require("jquery")):t(jQuery)}(function(s){var r=function(t,e){this.$element=s(t),this.options=s.extend({},r.DEFAULTS,this.dataOptions(),e),this.init()};r.DEFAULTS={from:0,to:0,speed:1e3,refreshInterval:100,decimals:0,formatter:function(t,e){return t.toFixed(e.decimals)},onUpdate:null,onComplete:null},r.prototype.init=function(){this.value=this.options.from,this.loops=Math.ceil(this.options.speed/this.options.refreshInterval),this.loopCount=0,this.increment=(this.options.to-this.options.from)/this.loops},r.prototype.dataOptions=function(){var t={from:this.$element.data("from"),to:this.$element.data("to"),speed:this.$element.data("speed"),refreshInterval:this.$element.data("refresh-interval"),decimals:this.$element.data("decimals")},e=Object.keys(t);for(var o in e){var i=e[o];void 0===t[i]&&delete t[i]}return t},r.prototype.update=function(){this.value+=this.increment,this.loopCount++,this.render(),"function"==typeof this.options.onUpdate&&this.options.onUpdate.call(this.$element,this.value),this.loopCount>=this.loops&&(clearInterval(this.interval),this.value=this.options.to,"function"==typeof this.options.onComplete&&this.options.onComplete.call(this.$element,this.value))},r.prototype.render=function(){var t=this.options.formatter.call(this.$element,this.value,this.options);this.$element.text(t)},r.prototype.restart=function(){this.stop(),this.init(),this.start()},r.prototype.start=function(){this.stop(),this.render(),this.interval=setInterval(this.update.bind(this),this.options.refreshInterval)},r.prototype.stop=function(){this.interval&&clearInterval(this.interval)},r.prototype.toggle=function(){this.interval?this.stop():this.start()},s.fn.countTo=function(n){return this.each(function(){var t=s(this),e=t.data("countTo"),o="object"==typeof n?n:{},i="string"==typeof n?n:"start";(!e||"object"==typeof n)&&(e&&e.stop(),t.data("countTo",e=new r(this,o))),e[i].call(e)})}});

/**
 * isInViewport
 * @author  Mudit Ameta
 * @license https://github.com/zeusdeux/isInViewport/blob/master/license.md MIT
 */
!function(e,n){"object"==typeof exports&&"undefined"!=typeof module?n(require("jquery")):"function"==typeof define&&define.amd?define(["jquery"],n):n(e.jQuery)}(this,function(e){"use strict";function n(n){var t=this;if(1===arguments.length&&"function"==typeof n&&(n=[n]),!(n instanceof Array))throw new SyntaxError("isInViewport: Argument(s) passed to .do/.run should be a function or an array of functions");return n.forEach(function(n){"function"!=typeof n?(console.warn("isInViewport: Argument(s) passed to .do/.run should be a function or an array of functions"),console.warn("isInViewport: Ignoring non-function values in array and moving on")):[].slice.call(t).forEach(function(t){return n.call(e(t))})}),this}function t(n){var t=e("<div></div>").css({width:"100%"});n.append(t);var o=n.width()-t.width();return t.remove(),o}function o(n,r){var i=n.getBoundingClientRect(),a=i.top,u=i.bottom,c=i.left,f=i.right,s=e.extend({tolerance:0,viewport:window},r),d=!1,l=s.viewport.jquery?s.viewport:e(s.viewport);l.length||(console.warn("isInViewport: The viewport selector you have provided matches no element on page."),console.warn("isInViewport: Defaulting to viewport as window"),l=e(window));var p=l.height(),w=l.width(),h=l[0].toString();if(l[0]!==window&&"[object Window]"!==h&&"[object DOMWindow]"!==h){var v=l[0].getBoundingClientRect();a-=v.top,u-=v.top,c-=v.left,f-=v.left,o.scrollBarWidth=o.scrollBarWidth||t(l),w-=o.scrollBarWidth}return s.tolerance=~~Math.round(parseFloat(s.tolerance)),s.tolerance<0&&(s.tolerance=p+s.tolerance),f<=0||c>=w?d:d=s.tolerance?a<=s.tolerance&&u>=s.tolerance:u>0&&a<=p}function r(n){if(n){var t=n.split(",");return 1===t.length&&isNaN(t[0])&&(t[1]=t[0],t[0]=void 0),{tolerance:t[0]?t[0].trim():void 0,viewport:t[1]?e(t[1].trim()):void 0}}return{}}e=e&&e.hasOwnProperty("default")?e.default:e,e.extend(e.expr.pseudos||e.expr[":"],{"in-viewport":e.expr.createPseudo?e.expr.createPseudo(function(e){return function(n){return o(n,r(e))}}):function(e,n,t){return o(e,r(t[3]))}}),e.fn.isInViewport=function(e){return this.filter(function(n,t){return o(t,e)})},e.fn.run=n});
//# sourceMappingURL=isInViewport.min.js.map

/**
 * Current device
 */
function soc_plugin_current_device() {

	var windowWidth = jQuery(window).width();
	if ( windowWidth >= 1024 ) {
		return 'desktop';
	} else if ( windowWidth >= 768 ) {
		return 'tablet';
	} else {
		return 'phone';
	}

}

/**
 * Tablet/Phone font sizes
 */
function soc_plugin_manage_font_sizes() {

	// vars
	var regularSize = false,
	tabletSize = false,
	phoneSize = false,
	currDevice = soc_plugin_current_device();

	// each headline
	jQuery('.soc-headline').each(function(){

		if ( jQuery(this).data('font-size-regular') ) {
			regularSize = jQuery(this).data('font-size-regular');
			tabletSize = regularSize;
			phoneSize = regularSize;
		}

		if ( jQuery(this).data('font-size-tablet') ) {
			tabletSize = jQuery(this).data('font-size-tablet');
		}

		if ( jQuery(this).data('font-size-phone') ) {
			phoneSize = jQuery(this).data('font-size-phone');
		}

		if ( currDevice == 'desktop' && regularSize ) {
			jQuery(this).css({ 'font-size' : regularSize })
		}

		if ( currDevice == 'tablet' && tabletSize ) {
			jQuery(this).css({ 'font-size' : tabletSize })
		}

		if ( currDevice == 'phone' && phoneSize ) {
			jQuery(this).css({ 'font-size' : phoneSize })
		}

	});

}

/**
 * Initiate tabs
 */
function soc_plugin_tabs_init() {

	// switching tabs
	jQuery(document).on( 'click', '.soc-tabs-nav-item', function(e){

		e.preventDefault();

		var container = jQuery(this).closest('.soc-tabs'),
		nav = container.find('.soc-tabs-nav'),
		navItems = nav.find('.soc-tabs-nav-item'),
		content = container.find('.soc-tabs-content'),
		contentItems = content.find('.soc-tabs-content-item');

		var nth = jQuery(this).index();

		// remove current active
		nav.find('.active').removeClass('active');
		content.find('.active').removeClass('active');

		// add new active
		navItems.eq(nth).addClass('active');
		contentItems.eq(nth).addClass('active');

	});

	// create navigation
	jQuery('.soc-tabs-nav').each(function(){

		var container = jQuery(this).closest('.soc-tabs'),
		nav = jQuery(this);

		container.find('.soc-tabs-content-item').each(function(){

			var tabTitle = jQuery(this).find('.soc-tabs-content-item-title').text();

			nav.append('<a href="#" class="soc-tabs-nav-item">' + tabTitle + '</a>');

		});

		nav.find('.soc-tabs-nav-item:first-child').trigger('click');

	});

}

/**
 * Initiate toggles
 */
function soc_plugin_toggles_init() {

	// toggling
	jQuery(document).on( 'click', '.soc-toggle-title', function(e){

		e.preventDefault();

		var container = jQuery(this).closest('.soc-toggles'),
		content = container.find('.soc-toggle');

		if ( ! jQuery(this).closest('.soc-toggle').hasClass('active') ) {

			// remove current active
			container.find('.active').removeClass('active');

			// add new active
			jQuery(this).closest('.soc-toggle').addClass('active');

		} else {

			// remove current active
			container.find('.active').removeClass('active');
			
		}

	});

}

/**
 * Initiate timers
 */
function soc_plugin_timers_init() {

	// each timer
	jQuery('.soc-timer').each(function(){

		// vars
		var element = jQuery(this),
		time = parseInt( jQuery(this).data('time') );

		// timeout
		setTimeout( function(){
			element.css({ visibility : 'visible' });
		}, time );

	});

}

jQuery(document).ready(function($){

	soc_plugin_tabs_init();
	soc_plugin_toggles_init();
	soc_plugin_timers_init();
	soc_plugin_manage_font_sizes();

});

jQuery(window).resize(function(){

	soc_plugin_manage_font_sizes();

});

/**
 * Counter
 */
jQuery(document).ready(function($){

	$('.soc-counter-number').text('');
 	
 	$('.soc-counter-number:not(.active):in-viewport').each(function(){
 		var start = 0;
 		var end = parseInt( $(this).data('count') );
 		$(this).countTo({
			from: start,
			to: end,
			speed: 1000,
			refreshInterval: 50,
			formatter: function (value, options) {
				return value.toFixed(options.decimals);
			}
		});
		$(this).addClass('active');
 	});

 	$(window).scroll(function(){
 		$('.soc-counter-number:not(.active):in-viewport').each(function(){
	 		var start = 0;
	 		var end = parseInt( $(this).data('count') );
	 		$(this).countTo({
				from: start,
				to: end,
				speed: 1000,
				refreshInterval: 50,
				formatter: function (value, options) {
					return value.toFixed(options.decimals);
				}
			});
			$(this).addClass('active');
	 	});

 	});

});

/**
 * Progress bar
 */

 jQuery(document).ready(function($){

 	$('.soc-progress-bar').each(function(){
 		var style = '';
 		if ( $(this).data('color') ) {
 			style = 'style="background-color:' + $(this).data('color') + '";';
 		}
 		$(this).append('<div class="soc-progress-bar-inner" ' + style + '>' + $(this).data('load') + '%' + '</div>');
 	});

 	$('.soc-progress-bar:not(.active):in-viewport').each(function(){
		var perc = $(this).data('load') + '%';
		$(this).addClass('active').find('.soc-progress-bar-inner').css({ width : perc });
	});

 	$(window).scroll(function(){
 		$('.soc-progress-bar:not(.active):in-viewport').each(function(){
 			var perc = $(this).data('load') + '%';
 			$(this).addClass('active').find('.soc-progress-bar-inner').css({ width : perc });
 		});
 	});

 });

/**
 * Accordion Menu
 */
 jQuery(document).ready(function($){

 	$('.soc-accordion-menu li').each(function(){
 		if ( $(this).find('ul').length ) {
 			$(this).children('a').append('<span class="soc-accordion-toggle"><span class="fa fa-angle-right"></span></span>');
 		}
 	});

 	$(document).on( 'click', '.soc-accordion-menu li a', function(e){

 		if ( $(this).closest('li').find('ul').length ) {
 		
	 		e.preventDefault();

	 		$(this).closest('li').toggleClass('soc-accordion-menu-active');
	 		if ( ! $(this).closest('li').hasClass('soc-accordion-menu-active') ) {
	 			$(this).closest('li').find('.soc-accordion-menu-active').removeClass('soc-accordion-menu-active');
	 		}

	 	}

 	});

 	if ( $('.soc-accordion-menu').length ) {
 		var current = $('.soc-accordion-menu').data('current');
 		if ( $('.soc-accordion-menu .page-item-' + current ).length ) {
 			$('.soc-accordion-menu .page-item-' + current ).addClass('soc-accordion-menu-current').parents('li').addClass('soc-accordion-menu-active');
 		}
 	}

 });
