<?php
if ( ! class_exists( 'MSOC_Shortcodes' ) ) {

	class MSOC_Shortcodes {

		public static function initialize() {
			// Icons
			add_shortcode( 'icon'           , array('MSOC_Shortcodes', 'icon_func') );

			// Dividers
			add_shortcode( 'soc_divider'        , array('MSOC_Shortcodes', 'soc_divider_func') );

			// Buttons
			add_shortcode( 'soc_button'         , array('MSOC_Shortcodes', 'soc_button_func') );

			// Panels
			add_shortcode( 'soc_panel'          , array('MSOC_Shortcodes', 'soc_panel_func') );

			// Columns
			add_shortcode( 'soc_one_half'       , array('MSOC_Shortcodes',  'soc_one_half_func') );
			add_shortcode( 'soc_one_third'      , array('MSOC_Shortcodes',  'soc_one_third_func') );
			add_shortcode( 'soc_two_third'      , array('MSOC_Shortcodes',  'soc_two_third_func') );
			add_shortcode( 'soc_one_fourth'     , array('MSOC_Shortcodes',  'soc_one_fourth_func') );
			add_shortcode( 'soc_three_fourth'   , array('MSOC_Shortcodes',  'soc_three_fourth_func') );
			add_shortcode( 'soc_one_fifth'      , array('MSOC_Shortcodes',  'soc_one_fifth_func') );

			// Limitations
			add_shortcode( 'soc_member'     , array('MSOC_Shortcodes',  'soc_member_func') );
			add_shortcode( 'soc_visitor'    , array('MSOC_Shortcodes',  'soc_visitor_func') );

			// Headline
			add_shortcode( 'soc_headline'     , array('MSOC_Shortcodes',  'soc_headline_func') );
			add_shortcode( 'soc_hero_banner'     , array('MSOC_Shortcodes',  'soc_hero_banner_func') );

			// Section
			add_shortcode( 'soc_full_section'     , array('MSOC_Shortcodes',  'soc_full_section_func') );

			// Testimonial
			add_shortcode( 'soc_testimonial'     , array('MSOC_Shortcodes',  'soc_testimonial_func') );

			// Tabs
			add_shortcode( 'soc_tabs'     , array('MSOC_Shortcodes',  'soc_tabs_func') );
			add_shortcode( 'soc_tab'     , array('MSOC_Shortcodes',  'soc_tab_func') );

			// Toggles
			add_shortcode( 'soc_toggles'     , array('MSOC_Shortcodes',  'soc_toggles_func') );
			add_shortcode( 'soc_toggle'     , array('MSOC_Shortcodes',  'soc_toggle_func') );

			// Timer
			add_shortcode( 'soc_timer'     , array('MSOC_Shortcodes',  'soc_timer_func') );

			// Widgets
			add_shortcode( 'soc_widget', array( 'MSOC_Shortcodes', 'soc_widget_func' ) );

			// Posts
			add_shortcode( 'soc_posts', array( 'MSOC_Shortcodes', 'soc_posts_func' ) );

			// Info Box
			add_shortcode( 'soc_info_box', array( 'MSOC_Shortcodes', 'soc_info_box_func' ) );

			// Progress bar
			add_shortcode( 'soc_progress_bar', array( 'MSOC_Shortcodes', 'soc_progress_bar_func' ) );			

			// Counter
			add_shortcode( 'soc_counter', array( 'MSOC_Shortcodes', 'soc_counter_func' ) );

			// Social
			add_shortcode( 'soc_social', array( 'MSOC_Shortcodes', 'soc_social_func' ) );

			// Timeline
			add_shortcode( 'soc_timeline', array( 'MSOC_Shortcodes', 'soc_timeline_func' ) );
			add_shortcode( 'soc_timeline_item', array( 'MSOC_Shortcodes', 'soc_timeline_item_func' ) );

			// Accordion Menu
			add_shortcode( 'soc_accordion_menu', array( 'MSOC_Shortcodes', 'soc_accordion_menu_func' ) );
			
			//Menu In Posts
			add_shortcode( 'soc_menu', array( 'MSOC_Shortcodes', 'soc_menu_func' ) );

			// Login
			add_shortcode( 'soc_login_form', array( 'MSOC_Shortcodes', 'soc_login_form_func' ) );			

			// Register
			add_shortcode( 'soc_register_form', array( 'MSOC_Shortcodes', 'soc_register_form_func' ) );			

			// User
			add_shortcode( 'soc_user_email', array( 'MSOC_Shortcodes', 'soc_user_email_func' ) );
			add_shortcode( 'soc_user_displayname', array( 'MSOC_Shortcodes', 'soc_user_displayname_func' ) );
			add_shortcode( 'soc_user_firstname', array( 'MSOC_Shortcodes', 'soc_user_firstname_func' ) );
			add_shortcode( 'soc_user_lastname', array( 'MSOC_Shortcodes', 'soc_user_lastname_func' ) );
			add_shortcode( 'soc_user_id', array( 'MSOC_Shortcodes', 'soc_user_id_func' ) );		

			// Align
			add_shortcode( 'soc_align', array( 'MSOC_Shortcodes', 'soc_align_func' ) );		

			// Big search form
			add_shortcode( 'soc_big_search', array( 'MSOC_Shortcodes', 'soc_big_search_func' ) );		

			// Last modified
			add_shortcode( 'soc_last_modified', array( 'MSOC_Shortcodes', 'soc_last_modified' ) );	
			
			// element
			add_shortcode( 'soc_element', array( 'MSOC_Shortcodes', 'soc_element' ) );	

		}


		/** ICONS **/
		public static function icon_func( $atts = [], $content = null ) {
			return "<i class='" . $atts['type'] . "'>" . $content . "</i>";
		}
		/** ICONS **/


		/** DIVIDERS **/
		public static function soc_divider_func( $atts = [], $content = null ) {
			$style = "";
			if ( !isset($atts['height']) ) {
				$style .= "height : 1px;";
			} else {
				$style .= "height : {$atts['height']}px; ";
			}
			if ( isset($atts['margin_top']) ) {
				$style .= "margin-top : {$atts['margin_top']}px; ";
			}
			if ( isset($atts['margin_bottom']) ) {
				$style .= "margin-bottom : {$atts['margin_bottom']}px; ";
			}
			if ( isset($atts['color']) ) {
				$style .= "background : {$atts['color']}; ";
			}
			return "<hr style='display:block;" . $style . "'>";
		}
		/** DIVIDERS **/


		/** BUTTONS **/
		public static function soc_button_func( $atts = [], $content = null ) {
			if ( !isset($atts['href']) || ($atts['href'] == "") ) {
				$href_link = "#";
			} else {
				$href_link = $atts['href'];
			}
			if ( !isset($atts['target']) || ($atts['target'] == "") ) {
				$target = "_self";
			} else {
				$target = "_blank";
			}

			if ( !isset($atts['align']) || ($atts['align'] == "") ) {
				$align = 'left';
			} else {
				$align = $atts['align'];
			}

			// rel
			if ( ! isset( $atts['rel'] ) || ( $atts['rel'] == '' ) ) {
				$rel = '';
			} else {
				$rel = 'rel="' . $atts['rel'] . '"';
			}

			if ( $align == 'left' ) {
				$return = "<a href='".$href_link."' target='".$target."' class='soc_button soc_".$atts['color']." soc_".$atts['size']."' $rel>".do_shortcode($content)."</a>";
			} elseif ( $align == 'right' ) {
				$return = "<a href='".$href_link."' target='".$target."' class='soc_button soc_button_right soc_".$atts['color']." soc_".$atts['size']."'  $rel>".do_shortcode($content)."</a>";
			} elseif ( $align == 'center' ) {
				$return = "<div class='soc_button_center'><a href='".$href_link."' target='".$target."' class='soc_button soc_".$atts['color']." soc_".$atts['size']."'  $rel>".do_shortcode($content)."</a></div>";
			}

			return $return;

		}
		/** BUTTONS **/


		/** PANELS **/
		public static function soc_panel_func( $atts = [], $content = null ) {

			$style = '';

			if ( isset( $atts['margin'] ) ) {
				$style = 'style="margin:' . $atts['margin'] . 'px;"';
			}

			return "<div class='soc_panel soc_panel_".$atts['color']."' $style>" . do_shortcode($content) . "</div>";

		}

		public static function soc_one_half_func( $atts = [], $content = null ) {
			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$line = "soc_last";
			} else {
				$line = "";
			}
			$html = "<div class='soc_one_half ".$line."'>" . do_shortcode($content) . "</div>";

			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$html .= "<div class='soc_clearboth'></div>";
			}
			
			return $html;
		}
		/** PANELS **/


		/** COLUMNS **/
		public static function soc_one_third_func( $atts = [], $content = null ) {
			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$line = "soc_last";
			} else {
				$line = "";
			}
			$html = "<div class='soc_one_third ".$line."'> " . do_shortcode($content) . "</div>";

			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$html .= "<div class='soc_clearboth'></div>";
			}
			
			return $html;
		}

		public static function soc_two_third_func( $atts = [], $content = null ) {
			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$line = "soc_last";
			} else {
				$line = "";
			}
			$html = "<div class='soc_two_third ".$line."'> " . do_shortcode($content) . "</div>";

			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$html .= "<div class='soc_clearboth'></div>";
			}
			
			return $html;
		}

		public static function soc_one_fourth_func( $atts = [], $content = null ) {
			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$line = "soc_last";
			} else {
				$line = "";
			}
			$html = "<div class='soc_one_fourth ".$line."'> " . do_shortcode($content) . "</div>";

			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$html .= "<div class='soc_clearboth'></div>";
			}
			
			return $html;
		}

		public static function soc_three_fourth_func( $atts = [], $content = null ) {
			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$line = "soc_last";
			} else {
				$line = "";
			}
			$html = "<div class='soc_three_fourth ".$line."'> " . do_shortcode($content) . "</div>";

			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$html .= "<div class='soc_clearboth'></div>";
			}
			
			return $html;
		}

		public static function soc_one_fifth_func( $atts = [], $content = null ) {
			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$line = "soc_last";
			} else {
				$line = "";
			}
			$html = "<div class='soc_one_fifth ".$line."'> " . do_shortcode($content) . "</div>";

			if ( isset($atts['class']) && ($atts['class'] == "last") ) {
				$html .= "<div class='soc_clearboth'></div>";
			}
			
			return $html;
		}
		/** COLUMNS **/


		/** LIMITATIONS **/
		public static function soc_member_func( $atts = [], $content = null ) {

			if ( is_user_logged_in() && !is_null( $content ) && !is_feed() ) {

				if ( isset( $atts['role'] ) ) {
					
					// if administrator return content
					if ( current_user_can( 'manage_options' ) ) {
						return do_shortcode( $content );
					}

					// allowed roles
					$roles_allowed = str_replace( ' ', '', $atts['role'] );
					$roles_allowed = explode( ',', $roles_allowed );

					// current user role
					$roles_user = wp_get_current_user();
					$roles_user = $roles_user->roles;

					if ( array_intersect( $roles_allowed, $roles_user ) ) {
						return do_shortcode( $content );
					}
				
				} else {
					return do_shortcode($content);
				}

			}

			return '';

		}

		public static function soc_visitor_func( $atts = [], $content = null ) {
			if ( ( !is_user_logged_in() && !is_null( $content ) ) || is_feed() )
				return do_shortcode($content);
			return '';
		}
		/** LIMITATIONS **/

		/** HEADLINE START **/
		
		public static function soc_headline_func( $atts = [], $content = '' ) {
			
			$atts = shortcode_atts( array(
				'color' => false,
				'font_size' => false,
				'font_size_tablet' => false,
				'font_size_phone' => false,
				'shadow' => '1',
				'align' => false,
				'margin_top' => false,
				'margin_bottom' => false,
				'element' => 'h2',
			), $atts, 'soc_headline' );

			$output = '';
			$output_style = '';
			$output_data = '';

			if ( $atts['color'] ) {
				$output_style .= 'color:' . $atts['color'] .';';
			}

			if ( $atts['font_size'] ) {
				$output_style .= 'font-size:' . $atts['font_size'] .'px;';
			}

			if ( $atts['align'] ) {
				$output_style .= 'text-align:' . $atts['align'] .';';
			}

			if ( $atts['shadow'] == '0' ) {
				$output_style .= 'text-shadow:none;';	
			}

			if ( $atts['margin_top'] ) {
				$output_style .= 'margin-top:' . $atts['margin_top'] .'px;';
			}

			if ( $atts['margin_bottom'] ) {
				$output_style .= 'margin-bottom:' . $atts['margin_bottom'] .'px;';
			}

			if ( $output_style != '' ) {
				$output_style = esc_attr( $output_style );
				$output_style = ' style="' . $output_style . '"';
			}

			if ( $atts['font_size_tablet'] ) {
				$output_data .= ' data-font-size-tablet="' . $atts['font_size_tablet'] . 'px"';
			}

			if ( $atts['font_size_phone'] ) {
				$output_data .= ' data-font-size-phone="' . $atts['font_size_phone'] . 'px"';
			}

			if ( $output_data !== '' && $atts['font_size'] ) {
				$output_data .= ' data-font-size-regular="' . $atts['font_size'] . 'px"';
			}

			$output .= '<' . $atts['element'] . ' class="soc-headline"';
			if ( $output_style != '' ) { $output .= $output_style; }
			if ( $output_data != '' ) { $output .= $output_data; }
			$output .= '>' . $content . '</' . $atts['element'] . '>';

			return do_shortcode( $output );

		}

		/** HEADLINE END **/

		/** HERO BANNER START **/
		
		public static function soc_hero_banner_func( $atts = [], $content = '' ) {
			
			$atts = shortcode_atts( array(
				'bgimage' => false,
				'bgcolor' => false,
				'margin_top' => false,
				'margin_bottom' => false,
				'margin_right' => false,
				'margin_left' => false,
				'padding_top' => false,
				'padding_bottom' => false,
				'padding_right' => false,
				'padding_left' => false,
				'height' => false,
				'min_height' => false,
				'parallax' => false,
			), $atts, 'soc_hero_banner' );

			$output = '';
			$output_style = '';
			$extra_class = '';

			// margin
			if ( $atts['margin_top'] ) {
				$output_style .= 'margin-top:' . $atts['margin_top'] .'px;';
			}

			if ( $atts['margin_bottom'] ) {
				$output_style .= 'margin-bottom:' . $atts['margin_bottom'] .'px;';
			}

			if ( $atts['margin_right'] ) {
				$output_style .= 'margin-right:' . $atts['margin_right'] .'px;';
			}

			if ( $atts['margin_left'] ) {
				$output_style .= 'margin-left:' . $atts['margin_left'] .'px;';
			}

			// padding
			if ( $atts['padding_top'] ) {
				$output_style .= 'padding-top:' . $atts['padding_top'] .'px;';
			}

			if ( $atts['padding_bottom'] ) {
				$output_style .= 'padding-bottom:' . $atts['padding_bottom'] .'px;';
			}

			if ( $atts['padding_right'] ) {
				$output_style .= 'padding-right:' . $atts['padding_right'] .'px;';
			}

			if ( $atts['padding_left'] ) {
				$output_style .= 'padding-left:' . $atts['padding_left'] .'px;';
			}

			// height
			if ( $atts['height'] && $atts['height'] !== 'auto' ) {
				$output_style .= 'height:' . $atts['height'] .'px;';
			}

			// min height
			if ( $atts['min_height'] && $atts['min_height'] !== '0' ) {
				$output_style .= 'min-height:' . $atts['min_height'] .'px;';
			}

			// image
			if ( $atts['bgimage'] ) {
				$output_style .= 'background-image:url(' . $atts['bgimage'] . ');';
			}
			// color
			if ( $atts['bgcolor'] ) {
				$output_style .= 'background-color:' . $atts['bgcolor'] .';';
			}
			// parallax
			if ( $atts['parallax'] == 1 ) {
				$extra_class = 'soc-parallax';
			}

			if ( $output_style != '' ) {
				$output_style = esc_attr( $output_style );
				$output_style = ' style="' . $output_style . '"';
			}

			$output .= '<div class="soc-hero-banner ' . $extra_class . '"';
			if ( $output_style != '' ) { $output .= $output_style; }
			$output .= '><div class="wrapper"><div class="soc-hero-banner-inside">' . $content . '</div></div></div>';

			return do_shortcode( $output );

		}

		/** HERO BANNER END **/

		/** FULL SECTION START **/
		
		public static function soc_full_section_func( $atts = [], $content = '' ) {
			
			$atts = shortcode_atts( array(
				'textcolor' => false,
				'bgcolor' => false,
				'bgimage' => false,
				'margin_top' => false,
				'margin_bottom' => false,
				'margin_right' => false,
				'margin_left' => false,
				'padding_top' => false,
				'padding_bottom' => false,
				'padding_right' => false,
				'padding_left' => false,
				'height' => false,
				'min_height' => false,
				'parallax' => false,
			), $atts, 'soc_full_section' );

			$output = '';
			$output_style = '';
			$output_wrapper_style = '';
			$extra_class = '';

			// margin
			if ( $atts['margin_top'] ) {
				$output_style .= 'margin-top:' . $atts['margin_top'] .'px;';
			}

			if ( $atts['margin_bottom'] ) {
				$output_style .= 'margin-bottom:' . $atts['margin_bottom'] .'px;';
			}

			if ( $atts['margin_right'] ) {
				$output_style .= 'margin-right:' . $atts['margin_right'] .'px;';
			}

			if ( $atts['margin_left'] ) {
				$output_style .= 'margin-left:' . $atts['margin_left'] .'px;';
			}

			// padding
			if ( $atts['padding_top'] ) {
				$output_wrapper_style .= 'padding-top:' . $atts['padding_top'] .'px;';
			}

			if ( $atts['padding_bottom'] ) {
				$output_wrapper_style .= 'padding-bottom:' . $atts['padding_bottom'] .'px;';
			}

			if ( $atts['padding_right'] ) {
				$output_wrapper_style .= 'padding-right:' . $atts['padding_right'] .'px;';
			}

			if ( $atts['padding_left'] ) {
				$output_wrapper_style .= 'padding-left:' . $atts['padding_left'] .'px;';
			}

			// height
			if ( $atts['height'] && $atts['height'] !== 'auto' ) {
				$output_style .= 'height:' . $atts['height'] .'px;';
			}

			// min height
			if ( $atts['min_height'] && $atts['min_height'] !== '0' ) {
				$output_style .= 'min-height:' . $atts['min_height'] .'px;';
			}

			// text color
			if ( $atts['textcolor'] ) {
				$output_style .= 'color:' . $atts['textcolor'] . ';';
			}

			// bg color
			if ( $atts['bgcolor'] ) {
				$output_style .= 'background-color:' . $atts['bgcolor'] . ';';
			}

			// image
			if ( $atts['bgimage'] ) {
				$output_style .= 'background-image:url(' . $atts['bgimage'] . ');';
			}

			// parallax
			if ( $atts['parallax'] == 1 ) {
				$extra_class = 'soc-parallax';
			}

			if ( $output_style != '' ) {
				$output_style = esc_attr( $output_style );
				$output_style = ' style="' . $output_style . '"';
			}

			if ( $output_wrapper_style != '' ) {
				$output_wrapper_style = esc_attr( $output_wrapper_style );
				$output_wrapper_style = ' style="' . $output_wrapper_style . '"';
			}

			$output .= '<div class="soc-full-section ' . $extra_class . '"';
			if ( $output_style != '' ) { $output .= $output_style; }
			$output .= '><div class="wrapper" '. $output_wrapper_style .'>' . $content . '</div></div>';

			return do_shortcode( $output );

		}

		/** FULL SECTION END **/

		/** TESTIMONIAL START **/
		
		public static function soc_testimonial_func( $atts = [], $content = '' ) {
			
			$atts = shortcode_atts( array(
				'image' => false,
				'name' => false,
				'maxwidth' => false,
				'max_width' => false,
				'bgcolor' => false,
				'stars' => false,
			), $atts, 'soc_testimonial' );

			$output = '';
			$output_style = '';
			$extra_class = '';

			if ( $atts['maxwidth'] ) {
				$atts['max_width'] = $atts['maxwidth'];
			}

			if ( $atts['max_width'] ) {
				$output_style .= 'max-width:' . $atts['max_width'] . 'px;';
			}
			
			// bg color
			if ( $atts['bgcolor'] ) {
				$output_style .= 'background-color:' . $atts['bgcolor'] . ';';
			}


			if ( $output_style != '' ) {
				$output_style = esc_attr( $output_style );
				$output_style = ' style="' . $output_style . '"';
			}

			$output .= '<div class="soc-testimonial ' . $extra_class . '" ' . $output_style . '>';
				if ( $atts['image'] ) {
					$output .= '<div class="soc-testimonial-image">';
						$output .= '<img class="soc-circle-img" src="' . $atts['image'] . '" alt="" />';
					$output .= '</div>';
				}
				$output .= '<div class="soc-testimonial-main">';
					$output .= '<div class="soc-testimonial-content">' . $content . '</div>';
					if ( $atts['name'] ) {
						$output .= '<div class="soc-testimonial-name">' . $atts['name'] . '</div>';
					}
					if ( $atts['stars'] ) {
						$output .= '<div class="soc-testimonial-stars">';
							$stars_count = intval($atts['stars']);
							for ($i=1; $i <= $stars_count; $i++) { 
								$output .= '<span class="fa fa-star"></span>';
							}
						$output .= '</div>';
					}
				$output .= '</div>';
			$output .= '</div>';

			return do_shortcode( $output );

		}

		/** TESTIMONIAL END **/

		/** TABS START **/
		
		public static function soc_tabs_func( $atts = [], $content = '' ) {

			$output = '';

			$output .= '<div class="soc-tabs">';
				$output .= '<div class="soc-tabs-nav"></div>';
				$output .= '<div class="soc-tabs-content">';
					$output .= do_shortcode( $content );	
				$output .= '</div>';
			$output .= '</div>';

			return do_shortcode( $output );

		}

		/** TABS END **/

		/** TAB START **/
		
		public static function soc_tab_func( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'title' => 'Untitled',
			), $atts, 'soc_tab' );

			$output = '';

			$output .= '<div class="soc-tabs-content-item">';
				$output .= '<div class="soc-tabs-content-item-title">' . $atts['title'] . '</div>';
				$output .= '<div class="soc-tabs-content-item-main">';
					$output .= do_shortcode( $content );
				$output .= '</div>';
			$output .= '</div>';

			return do_shortcode( $output );

		}

		/** TAB END **/

		/** TOGGLES START **/
		
		public static function soc_toggles_func( $atts = [], $content = '' ) {

			$output = '';

			$output .= '<div class="soc-toggles">';
				$output .= do_shortcode( $content );	
			$output .= '</div>';

			return do_shortcode( $output );

		}

		/** TOGGLES END **/

		/** TOGGLE START **/
		
		public static function soc_toggle_func( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'title' => 'Untitled',
			), $atts, 'soc_toggle' );

			$output = '';

			$output .= '<div class="soc-toggle">';
				$output .= '<div class="soc-toggle-title">' . $atts['title'] . '<span class="soc-toggle-indicator"></span></div>';
				$output .= '<div class="soc-toggle-main">';
					$output .= do_shortcode( $content );
				$output .= '</div>';
			$output .= '</div>';

			return do_shortcode( $output );

		}

		/** TOGGLE END **/

		/** TIMER START **/
		
		public static function soc_timer_func( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'seconds' => '5',
			), $atts, 'soc_timer' );

			$output = '';

			$output .= '<div class="soc-timer" data-time="' . $atts['seconds'] * 1000 . '">' . $content . '</div>';

			return do_shortcode( $output );

		}

		/** TIMER END **/

		/** WIDGET START **/
		
		public static function soc_widget_func( $atts = [], $content = '' ) {

			// if no name set default to archives
			if ( ! isset( $atts['name'] ) ) {
				$atts['name'] = 'WP_Widget_Archives';
			}

			$output = '<div class="soc-widget">';
				ob_start();
					the_widget( $atts['name'], $atts, array() ); 
				$output .= ob_get_contents();
				ob_end_clean();
			$output .= '</div>';

			return do_shortcode( $output );

		}

		/** WIDGET END **/

		/** POSTS START **/

		public static function soc_posts_func( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'columns' => 1,
				'num_posts' => 4,
				'cat_id' => false,
				'post_id' => false,
				'order' => 'DESC',
				'orderby' => 'date',
				'thumb' => '1',
				'date_meta' => '1',
				'excerpt' => '1',
				'style' => '1',
				'related' => false,
				'thumbnail_size' => 'large',
				'excerpt_length' => false,
			), $atts, 'soc_posts' );

			$output = '';

			// query args
			$args = array(
				'posts_per_page' => $atts['num_posts'],
				'order' => $atts['order'],
				'orderby' => $atts['orderby'],
				'no_found_rows' => true,
				'ignore_sticky_posts' => true,
			);

			// post ID
			if ( $atts['post_id'] ) {
				$post_ids = explode(',', trim( $atts['post_id'] ) );
				$args['post__in'] = $post_ids;
			}

			// exclude currently shown post
			if ( is_single() ) {
				$args['post__not_in'] = array( get_the_ID() );
			}

			// category ID
			if ( $atts['cat_id'] ) {
				$cat_ids = explode(',', trim( $atts['cat_id'] ) );
				$args['category__in'] = $cat_ids;
			}

			// related
			if ( $atts['related'] ) {
				$current_post_categories = wp_get_post_categories( get_the_ID() );
				$args['category__in'] = $current_post_categories;
				$args['post__not_in'] = array( get_the_ID() );
			}

			// query posts
			$socrates_plugin_query = new WP_Query( $args );

			// if there are posts
			if ( $socrates_plugin_query->have_posts() ) :

				$count = 0;
				$real_count = 0;

				// start output buffer
				ob_start();
				?>

				<div class="soc-posts soc-posts-style-<?php echo esc_attr( $atts['style'] ); ?>">

					<?php while ( $socrates_plugin_query->have_posts() ) : $socrates_plugin_query->the_post(); ?>

						<?php
							$count++;
							$real_count++;

							// cols class
							$class_cols = '';
							$max_cols = 1;
							if ( $atts['columns'] == 2 ) {
								$class_cols = 'soc_one_half';
								$max_cols = 2;
							} elseif ( $atts['columns'] == 3 ) {
								$class_cols = 'soc_one_third';
								$max_cols = 3;
							} elseif ( $atts['columns'] == 4 ) {
								$class_cols = 'soc_one_fourth';
								$max_cols = 4;
							} elseif ( $atts['columns'] == 5 ) {
								$class_cols = 'soc_one_fifth';
								$max_cols = 5;
							}

							// cols last class
							if ( $count == $max_cols ) {
								$class_cols .= ' soc_last';
							}
						?>

						<div class="soc-post <?php echo $class_cols; ?>">
							
							<?php if ( has_post_thumbnail() && $atts['thumb'] != '0' ) : ?>
								<div class="soc-post-thumb">
									<a href="<?php the_permalink(); ?>"><?php the_post_thumbnail( $atts['thumbnail_size'] ); ?></a>
								</div><!-- .soc-post-thumb -->
							<?php endif; ?>

							<div class="soc-post-main">

								<h3 class="soc-post-title"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h3>
								
								<?php if ( $atts['date_meta'] != '0' ) : ?>	<div class="soc-post-meta">
								<span class="post-meta-date"><?php the_time( get_option( 'date_format' ) ); ?></span>			
								<span class="post-meta-cats"><?php the_category( ', ' ); ?></span>
								<span class="post-meta-comments"><a href="<?php comments_link(); ?>"><?php comments_number( esc_html__( 'No Comments', 'speaker-theme' ), esc_html__( 'One Comment', 'speaker-theme' ), esc_html__( '% Comments', 'speaker-theme' ) ); ?></a></span>
								</div>
								<?php endif; ?>

								<?php if ( $atts['excerpt'] != '0' ) : ?>
									<div class="soc-post-excerpt">
										<?php 
											if ( ! $atts['excerpt_length'] ) {
												the_excerpt(); 
											} else {
												$custom_excerpt = get_the_excerpt();
												echo wp_trim_words( $custom_excerpt , $atts['excerpt_length'] ); 
											}
										?>
									</div>
								<?php endif; ?>

							</div><!-- .soc-post-main -->

						</div><!-- .soc-post -->

						<?php 
							// reset count
							if ( $count == $max_cols ) {
								$count = 0;
							}
						?>

					<?php endwhile; ?>

				</div><!-- .soc-posts -->

				<?php
				// collect output and end output buffer
				$output .= ob_get_contents();
				ob_end_clean();

			endif;

			wp_reset_postdata();

			return do_shortcode( $output );

		}

		/** POSTS END **/

		/** INFO BOX START **/

		public static function soc_info_box_func( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'image' => false,
				'icon' => false,
				'button_text' => 'Button text',
				'button_url' => false,
				'max_width' => false,
				'style' => '1'
			), $atts, 'soc_info_box' );

			$output = '';


			$count = 0;
			$real_count = 0;

			// start output buffer
			ob_start();
			?>

				<div class="soc-info-box soc-info-box-style-<?php echo $atts['style']; ?>" <?php if ( $atts['max_width'] ) echo 'style="max-width:' . esc_attr( $atts['max_width'] ) . '"'; ?>>

					<?php if ( $atts['image'] ) : ?>
						<div class="soc-info-box-image">
							<img src="<?php echo esc_url( $atts['image'] ); ?>" alt="" />
						</div><!-- .soc-info-box-image -->
					<?php endif; ?>

					<?php if ( $atts['icon'] ) : ?>
						<div class="soc-info-box-icon">
							<span class="fa fa-<?php echo $atts['icon']; ?>"></span>
						</div><!-- .soc-info-box-icon -->
					<?php endif; ?>

					<?php if ( $content ) : ?>
						<div class="soc-info-box-content">
							<?php echo $content; ?>
						</div><!-- .soc-info-box-content -->
					<?php endif; ?>

					<?php if ( $atts['button_url'] ) : ?>
						<div class="soc-info-box-button">
							<a href="<?php echo esc_url( $atts['button_url'] ); ?>"><?php echo $atts['button_text']; ?></a>
						</div><!-- .soc-info-box-button -->
					<?php endif; ?>

				</div><!-- .soc-info-box -->

			<?php
			// collect output and end output buffer
			$output .= ob_get_contents();
			ob_end_clean();

			return do_shortcode( $output );

		}

		/** INFO BOX END **/

		/** PROGRESS BAR START **/

		public static function soc_progress_bar_func( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'amount' => 100,
				'title' => false,
				'color' => false,
			), $atts, 'soc_info_box' );

			$output = '';


			$count = 0;
			$real_count = 0;

			// start output buffer
			ob_start();
			?>

				<div class="soc-progress-bar-wrap">
					<?php if ( $atts['title'] ) : ?>
						<div class="soc-progress-bar-header">
							<span class="soc-progress-bar-title"><?php echo $atts['title']; ?></span>
						</div><!-- .soc-progress-bar-header -->
					<?php endif; ?>
					<div class="soc-progress-bar" <?php if ( $atts['color'] ) echo 'data-color="' . esc_attr( $atts['color'] ) . '"'; ?> data-load="<?php echo esc_attr( $atts['amount'] ); ?>"></div>
				</div><!-- .soc-progress-bar-wrap -->

			<?php
			// collect output and end output buffer
			$output .= ob_get_contents();
			ob_end_clean();

			return do_shortcode( $output );

		}

		/** PROGRESS BAR END **/

		/** COUNTER START **/

		public static function soc_counter_func( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'number' => 100,
				'title' => false,
				'icon' => false,
				'color' => false,
				'align' => 'left',
				'font_size' => false
			), $atts, 'soc_counter' );

			$output = '';

			$icon_style = 'style="';

				if ( $atts['color'] ) {
					$icon_style .= 'color:' . $atts['color'] . ';';
				}

				if ( $atts['font_size'] ) {
					$icon_style .= 'font-size:' . $atts['font_size'] . 'px;';
				}

			$icon_style .= '"';


			// start output buffer
			ob_start();
			?>

				<div class="soc-counter soc-counter-align-<?php echo esc_attr( $atts['align'] ); ?>">
					<?php if ( $atts['icon'] ) : ?>
						<div class="soc-counter-icon" <?php echo $icon_style; ?>>
							<span class="fa fa-<?php echo esc_attr( $atts['icon'] ); ?>"></span>
						</div><!-- .soc-counter-icon -->
					<?php endif; ?>
					<div class="soc-counter-main">
						<div class="soc-counter-number" <?php echo $icon_style; ?> data-count="<?php echo esc_attr( $atts['number'] ); ?>"><?php echo $atts['number']; ?></div>
						<?php if ( $atts['title'] ) : ?>
							<div class="soc-counter-title"><?php echo $atts['title']; ?></div>
						<?php endif; ?>
					</div><!-- .soc-counter-main -->
				</div><!-- .soc-counter -->

			<?php
			// collect output and end output buffer
			$output .= ob_get_contents();
			ob_end_clean();

			return do_shortcode( $output );

		}

		/** COUNTER END **/

		/** SOCIAL START **/

		public static function soc_social_func( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'number' => 100,
				'title' => false,
				'icon' => false,
				'twitter' => false,
				'facebook' => false,
				'youtube' => false,
				'vimeo' => false,
				'tumblr' => false,
				'pinterest' => false,
				'linkedin' => false,
				'instagram' => false,
				'github' => false,
				'googleplus' => false,
				'rss' => false,
				'color' => false,
				'align' => 'left',
			), $atts, 'soc_social' );

			$output = '';

			// start output buffer
			ob_start();
			?>

				<div class="soc-social soc-social-align-<?php echo esc_attr( $atts['align'] ); ?>">
					<?php if ( $atts['twitter'] ) : ?>
						<a href="<?php echo esc_url( $atts['twitter'] ); ?>" target="_blank" <?php if ( $atts['color'] ) echo 'style="background-color:' . esc_attr( $atts['color'] ) . ';"'; ?>><span class="fa fa-twitter"></span></a>
					<?php endif; ?>
					<?php if ( $atts['facebook'] ) : ?>
						<a href="<?php echo esc_url( $atts['facebook'] ); ?>" target="_blank" <?php if ( $atts['color'] ) echo 'style="background-color:' . esc_attr( $atts['color'] ) . ';"'; ?>><span class="fa fa-facebook"></span></a>
					<?php endif; ?>
					<?php if ( $atts['youtube'] ) : ?>
						<a href="<?php echo esc_url( $atts['youtube'] ); ?>" target="_blank" <?php if ( $atts['color'] ) echo 'style="background-color:' . esc_attr( $atts['color'] ) . ';"'; ?>><span class="fa fa-youtube-play"></span></a>
					<?php endif; ?>
					<?php if ( $atts['vimeo'] ) : ?>
						<a href="<?php echo esc_url( $atts['vimeo'] ); ?>" target="_blank" <?php if ( $atts['color'] ) echo 'style="background-color:' . esc_attr( $atts['color'] ) . ';"'; ?>><span class="fa fa-vimeo"></span></a>
					<?php endif; ?>
					<?php if ( $atts['tumblr'] ) : ?>
						<a href="<?php echo esc_url( $atts['tumblr'] ); ?>" target="_blank" <?php if ( $atts['color'] ) echo 'style="background-color:' . esc_attr( $atts['color'] ) . ';"'; ?>><span class="fa fa-tumblr"></span></a>					
					<?php endif; ?>
					<?php if ( $atts['pinterest'] ) : ?>
						<a href="<?php echo esc_url( $atts['pinterest'] ); ?>" target="_blank" <?php if ( $atts['color'] ) echo 'style="background-color:' . esc_attr( $atts['color'] ) . ';"'; ?>><span class="fa fa-pinterest"></span></a>
					<?php endif; ?>
					<?php if ( $atts['linkedin'] ) : ?>
						<a href="<?php echo esc_url( $atts['linkedin'] ); ?>" target="_blank" <?php if ( $atts['color'] ) echo 'style="background-color:' . esc_attr( $atts['color'] ) . ';"'; ?>><span class="fa fa-linkedin"></span></a>
					<?php endif; ?>
					<?php if ( $atts['instagram'] ) : ?>
						<a href="<?php echo esc_url( $atts['instagram'] ); ?>" target="_blank" <?php if ( $atts['color'] ) echo 'style="background-color:' . esc_attr( $atts['color'] ) . ';"'; ?>><span class="fa fa-instagram"></span></a>
					<?php endif; ?>
					<?php if ( $atts['github'] ) : ?>
						<a href="<?php echo esc_url( $atts['github'] ); ?>" target="_blank" <?php if ( $atts['color'] ) echo 'style="background-color:' . esc_attr( $atts['color'] ) . ';"'; ?>><span class="fa fa-github"></span></a>
					<?php endif; ?>
					<?php if ( $atts['googleplus'] ) : ?>
						<a href="<?php echo esc_url( $atts['googleplus'] ); ?>" target="_blank" <?php if ( $atts['color'] ) echo 'style="background-color:' . esc_attr( $atts['color'] ) . ';"'; ?>><span class="fa fa-google-plus"></span></a>
					<?php endif; ?>
					<?php if ( $atts['rss'] ) : ?>
						<a href="<?php echo esc_url( $atts['rss'] ); ?>" target="_blank" <?php if ( $atts['color'] ) echo 'style="background-color:' . esc_attr( $atts['color'] ) . ';"'; ?>><span class="fa fa-rss"></span></a>
					<?php endif; ?>
				</div><!-- .soc-social -->

			<?php
			// collect output and end output buffer
			$output .= ob_get_contents();
			ob_end_clean();

			return do_shortcode( $output );

		}

		/** SOCIAL END **/

		/** TIMELINE START **/

		public static function soc_timeline_func( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				
			), $atts, 'soc_social' );

			$output = '';

			// start output buffer
			ob_start();
			?>

				<div class="soc-timeline">
					<?php echo do_shortcode( $content ); ?>
				</div><!-- .soc-timeline -->

			<?php
			// collect output and end output buffer
			$output .= ob_get_contents();
			ob_end_clean();

			return do_shortcode( $output );

		}

		public static function soc_timeline_item_func( $atts = [], $content = false ) {

			$atts = shortcode_atts( array(
				'date' => false,
				'title' => false,
			), $atts, 'soc_social' );

			$output = '';

			// start output buffer
			ob_start();
			?>

				<div class="soc-timeline-item">
					<?php if ( $atts['date'] ) : ?>
						<span class="soc-timeline-date"><?php echo esc_attr( $atts['date'] ); ?></span>
					<?php endif; ?>
					<?php if ( $atts['title'] ) : ?>
						<h4 class="soc-timeline-title"><?php echo esc_attr( $atts['title'] ); ?></h4>
					<?php endif; ?>
					<?php if ( $content ) : ?>
						<div class="soc-timeline-content">
							<?php echo $content; ?>
						</div><!-- .soc-timeline-content -->
					<?php endif; ?>
				</div><!-- .soc-timeline-item -->

			<?php
			// collect output and end output buffer
			$output .= ob_get_contents();
			ob_end_clean();

			return do_shortcode( $output );

		}

		/** TIMELINE END **/

		/** ACCORDION MENU START */

		public static function soc_accordion_menu_func( $atts = [], $content = false ) {

			$atts = shortcode_atts( array(
				'menu' => false,
			), $atts, 'soc_accordion_menu' );

			$output = '';

			if ( ! $atts['menu'] ) {
				return;
			}

			$nav_menu = wp_get_nav_menu_object( $atts['menu'] );

			$current_id = '';
			if ( is_singular() ) {
				$current_id = get_the_ID();
			}

			// start output buffer
			ob_start();
			?>

				<div class="soc-accordion-menu" data-current="<?php echo $current_id; ?>">
					<?php wp_nav_menu( array( 'fallback_cb' => '', 'menu' => $nav_menu ) ); ?>
				</div><!-- .soc-accordion-menu -->

			<?php
			// collect output and end output buffer
			$output .= ob_get_contents();
			ob_end_clean();

			return do_shortcode( $output );

		}

		/** ACCORDION MENU END **/
		
		/** POST MENU START */
			
			public static function soc_menu_func( $atts = [], $content = false ) {
			
			extract(
			shortcode_atts(
			array( 'name' => null, ),
			$atts
				)
			);
			return wp_nav_menu(
			array(
			'menu' => $name,
			'echo' => false
			)
			);
			}
			
		/** POST MENU END */

		/** LOGIN FORM START */

		public static function soc_login_form_func( $atts = [], $content = false ) {

			$atts = shortcode_atts( array(
				'redirect' => false,
			), $atts, 'soc_login_form' );

			if ( is_user_logged_in() ) {
				return '';
			}

			$output = '';

			$args = array();
			
			if ( $atts['redirect'] ) {
				$args['redirect'] = $atts['redirect'];
			}

			// start output buffer
			ob_start();
			?>

				<div class="soc-login-form">
					<?php if ( ! empty( $_GET['soc_login'] ) && $_GET['soc_login'] == 'failed' ) : ?>
						<div class="soc-login-form-error"><?php esc_html_e( 'The username or password is incorrect' ); ?> - <a href="<?php echo wp_lostpassword_url( get_permalink() ); ?>" title="Lost Password"><?php esc_html_e( 'Password reminder' ); ?></a></div>
					<?php endif; ?>	
					<?php wp_login_form( $args ); ?>
				</div><!-- .soc-login-form -->

			<?php
			// collect output and end output buffer
			$output .= ob_get_contents();
			ob_end_clean();

			return do_shortcode( $output );

		}

		/** LOGIN FORM END **/

		/** REGISTER FORM START */

		public static function soc_register_form_func( $atts = [], $content = false ) {

			$options = get_option( 'soc_custom_codes' );

			$atts = shortcode_atts( array(
				'redirect' => $_SERVER['REQUEST_URI'],
				'role' => false,
			), $atts, 'soc_register_form' );

			if ( is_user_logged_in() ) {
				return '';
			}

			$output = '';

			global $socrates_register_errors;
			$errors = $socrates_register_errors;

			// start output buffer
			ob_start();
			?>

				<div class="soc-register-form">

					<?php if ( ! empty( $errors ) ) : ?>
						<div class="soc-register-form-error">
							<?php foreach ( $errors as $error ) : ?>
								<p><?php echo $error; ?></p>
							<?php endforeach; ?>
						</div><!-- .soc-register-form-error -->
					<?php endif; ?>

					<form method="post" onsubmit="return checkForm(this);" action="<?php echo esc_url($_SERVER['REQUEST_URI']); ?>">
						
						<p>
							<label for="soc_register_username"><?php esc_html_e( 'Username', 'socrates-plugin' ); ?></label>
							<input name="soc_register_username" type="text" value="<?php echo(isset($_POST['soc_register_username']) ? $_POST['soc_register_username'] : null); ?>" id="soc_register_username" required />
						</p>

						<?php if ( is_array( $options ) && isset( $options['soc_membership_enable_first_name'] ) && $options['soc_membership_enable_first_name'] == 'on' ) : ?>
							<p>
								<label for="soc_register_first_name"><?php esc_html_e( 'First Name', 'socrates-plugin' ); ?></label>
								<input name="soc_register_first_name" type="text" value="<?php echo(isset($_POST['soc_register_first_name']) ? $_POST['soc_register_first_name'] : null); ?>" id="soc_register_first_name" required />
							</p>
						<?php endif; ?>

						<?php if ( is_array( $options ) && isset( $options['soc_membership_enable_last_name'] ) && $options['soc_membership_enable_last_name'] == 'on' ) : ?>
							<p>
								<label for="soc_register_last_name"><?php esc_html_e( 'Last Name', 'socrates-plugin' ); ?></label>
								<input name="soc_register_last_name" type="text" value="<?php echo(isset($_POST['soc_register_last_name']) ? $_POST['soc_register_last_name'] : null); ?>" id="soc_register_last_name" required />
							</p>
						<?php endif; ?>

						<p>
							<label for="soc_register_email"><?php esc_html_e( 'Email', 'socrates-plugin' ); ?></label>
							<input name="soc_register_email" type="email" value="<?php echo(isset($_POST['soc_register_email']) ? $_POST['soc_register_email'] : null); ?>" id="soc_register_email" required />
						</p>

						<p>
							<label for="soc_register_password"><?php esc_html_e( 'Password ', 'socrates-plugin' ); ?></label>
							<input name="soc_register_password" type="password" id="soc_register_password" required />
							<div class="soc_password_notice"><?php esc_html_e( 'Hint: 8 character min. alphanumeric including Uppercase letter', 'socrates-plugin' ); ?></div>
						</p>
						<p><input type="checkbox" required name="soc_terms">  <span class="checkmark"></span><span class="soc_terms"><?php esc_html_e( ' I Accept The Terms Of This Site.', 'socrates-plugin' ); ?></span></p>
						<input type="submit" name="soc_register_submit" value="<?php esc_html_e( 'Submit Registration', 'socrates-plugin' ); ?>"/>

						<?php if ( $atts['redirect'] ) : ?>
							<input type="hidden" name="soc_register_redirect" value="<?php echo esc_url( $atts['redirect'] ); ?>" />
						<?php endif; ?>

						<?php if ( $atts['role'] ) : ?>
							<?php
								$role_ids = get_option( 'soc_user_role_ids' );
								$role_id = $role_ids[$atts['role']];
							?>
							<input type="hidden" name="soc_register_r_id" value="<?php echo $role_id; ?>" />
						<?php endif; ?>

						<?php wp_nonce_field( 'soc_register', 'soc_register_nonce' ); ?>

					</form>

				</div><!-- .soc-register-form -->

			<?php
			// collect output and end output buffer
			$output .= ob_get_contents();
			ob_end_clean();

			return do_shortcode( $output );

		}

		/** REGISTER FORM END **/

		/** USER SHORTCODES START **/

		public static function soc_user_email_func( $atts = [], $content = false ) {

			if ( ! is_user_logged_in() ) {
				return '';
			}

			$user = wp_get_current_user();
			return $user->user_email;

		}

		public static function soc_user_displayname_func( $atts = [], $content = false ) {

			if ( ! is_user_logged_in() ) {
				return '';
			}

			$user = wp_get_current_user();
			return $user->display_name;

		}

		public static function soc_user_firstname_func( $atts = [], $content = false ) {

			if ( ! is_user_logged_in() ) {
				return '';
			}

			$user = wp_get_current_user();
			if ( ! empty( $user->first_name ) ) {
				return $user->first_name;
			}

		}

		public static function soc_user_lastname_func( $atts = [], $content = false ) {

			if ( ! is_user_logged_in() ) {
				return '';
			}

			$user = wp_get_current_user();
			if ( ! empty( $user->last_name ) ) {
				return $user->last_name;
			}

		}

		public static function soc_user_id_func( $atts = [], $content = false ) {

			if ( ! is_user_logged_in() ) {
				return '';
			}

			$user = wp_get_current_user();
			return $user->ID;

		}

		/** USER SHORTCODES END **/

		/** ALIGN SHORTCODE START **/

		public static function soc_align_func( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'align' => 'center',
				'max_width' => false
			), $atts, 'soc_align' );

			$style = '';
			if ( $atts['max_width'] ) {
				$style = ' style="max-width:' . $atts['max_width'] . ';"';
			}

			$class = 'soc-align-inner';
			if ( strpos( $content, '[video' ) !== false ) {
				$class .= ' soc-align-display-block';
			}

			return do_shortcode( '<div class="soc-align soc-align-' . $atts['align'] . '"><div class="' . $class . '"'.$style.'>' . $content . '</div></div>' );

		}

		/** ALIGN SHORTCODE END **/

		/** SEARCH FORM START **/

		public static function soc_big_search_func( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'margin_top' => false,
				'margin_bottom' => false,
			), $atts, 'soc_align' );

			$style = '';
			if ( $atts['margin_top'] ) {
				$style .= 'margin-top:' . $atts['margin_top'] .'px;';
			}
			if ( $atts['margin_bottom'] ) {
				$style .= 'margin-bottom:' . $atts['margin_bottom'] .'px;';
			}
			if ( ! empty( $style ) ) {
				$style = 'style="' . $style . '"';
			}

			$form = '<form role="search" method="get" class="search-form" action="' . home_url( '/' ) . '" >
						<label class="screen-reader-text" for="s">' . __( 'Search for:', 'socrates-plugin' ) . '</label>
						<input type="text" value="' . get_search_query() . '" name="s" />
						<button type="submit" class="search-submit" value="Search"><span class="screen-reader-text"></span><span class="fa fa-search"></span></button>
					</form>';

			return do_shortcode( '<div class="soc-big-search"' . $style . '>' . $form . '</div>' );

		}

		/** SEARCH FORM END **/

		/* LAST MODIFIED START */

		public static function soc_last_modified( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'format' => get_option( 'date_format' ),
			), $atts, 'soc_last_modified' );

			return do_shortcode( '<span class="soc-last-modified">' . get_the_modified_time( $atts['format'] ) . '</span>' );

		}

		/* LAST MODIFIED END */

		/* ELEMENT START */

		public static function soc_element( $atts = [], $content = '' ) {

			$atts = shortcode_atts( array(
				'tag' => 'div',
				'class' => false,
				'id' => false,
			), $atts, 'soc_element' );

			$append = '';

			if ( $atts['class'] ) {
				$append .= ' class="' . $atts['class'] . '"';
			}

			if ( $atts['id'] ) {
				$append .= ' id="' . $atts['id'] . '"';
			}

			return do_shortcode( '<' . $atts['tag'] . $append . '>' . $content . '</'. $atts['tag'] .'>' );

		}

		/* ELEMENT END */


	}
	
			/** BROWSER SHORTCODES **/
		add_shortcode('soc_show', 'soc_showto');
		function soc_showto($atts, $content = null){
			extract(shortcode_atts(array('browser' => ''), $atts));
			$showcontent = null; $classes = get_body_class(); 
			$b = explode("/[\s,]+/",$browser);
			foreach ($classes as $c){
				$match = array_search($c,$b);
				if($match !== FALSE){
					$showcontent = do_shortcode($content);
				} 
			}
			return $showcontent;
		}

		// Browser Show Shortcode 
		add_shortcode('soc_hide', 'soc_hidefrom');
		function soc_hidefrom($atts, $content = null){
			extract(shortcode_atts(array('browser' => ''), $atts));
			$hiddencontent = do_shortcode($content); $classes = get_body_class();
			$b = explode("/[\s,]+/",$browser);
			foreach ($classes as $c){
				$match = array_search($c,$b);
				if($match !== FALSE){
					$hiddencontent = null;
				}
			}
			return $hiddencontent;
		}
		/** BROWSER SHORTCODES END **/
}

