<?php

if ( ! class_exists( 'MSOC_Tinymce_buttons' ) ) {

	class MSOC_Tinymce_buttons {

		public static function initialize() {
			add_filter("mce_external_plugins",            array('MSOC_Tinymce_buttons', 'addPlugin'));
			add_filter('mce_buttons',                     array('MSOC_Tinymce_buttons', 'registerButtons'));
			add_action('admin_enqueue_scripts',           array('MSOC_Tinymce_buttons', 'loadAssets'), 10, 1 );

		}

		public static function loadAssets() {
			wp_localize_script( 'soc-tiny', 'soc_tinymce_data',
				array(
					'buttons' => json_decode(file_get_contents(SOC_PATH . '/shortcodes/buttons.json'), true),
					'icons'   => json_decode(file_get_contents(SOC_PATH . '/shortcodes/icons.json'  ), true),
					'baseURL' => SOC_URL
			));
		}

		public static function addPlugin($plugin_array) {
			$plugin_array['soc_shortcodes'] = SOC_URL . 'assets/js/tinymce_buttons/soc_shortcodes.js';
			return $plugin_array;
		}

		public static function registerButtons($buttons) {
			array_push($buttons, "soc_shortcodes");
			return $buttons;
		}

	}
}
